import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import kwm.*;

public class BouncingBall 
{
  // delay in milliseconds (1000/DELAY frames per second)
  private static final int DELAY = 40;
  
  // width and height of drawing area
  private static final int WIDTH = 600;
  private static final int HEIGHT = 400;
  
  // radius and color of ball
  private static final int RADIUS = 15;
  
  public static void main(String[] args)
  {
    // open window
    Drawing.begin("Bouncing Ball", WIDTH, HEIGHT);
    
    // create and register listener
    BallListener listener = new BallListener();
    Timer timer = new Timer(DELAY, listener);
    
    // run program until window is closed
    timer.start(); 
    try 
    { 
      synchronized(timer) { timer.wait(); }
    }
    catch(InterruptedException e)
    { }
  }
  
  private static class BallListener implements ActionListener
  {
    // position and velocity of ball
    private int x = 117;
    private int y = 63;
    private int vx = 17;
    private int vy = 13;
    
    // execute animation step
    public void actionPerformed(ActionEvent e) 
    {
      // update model
      x += vx;
      y += vy;
      if (x <= RADIUS) { x = RADIUS; vx = -vx; }
      if (y <= RADIUS) { y = RADIUS; vy = -vy; }
      if (x >= WIDTH-RADIUS)  { x = WIDTH-RADIUS;  vx = -vx; }
      if (y >= HEIGHT-RADIUS) { y = HEIGHT-RADIUS; vy = -vy; }
      
      // draw model
      Drawing.graphics.clearRect(0, 0, WIDTH, HEIGHT);
      Drawing.graphics.setColor(Color.orange);
      Drawing.graphics.fillOval(x-RADIUS, y-RADIUS, 2*RADIUS, 2*RADIUS);
      Drawing.graphics.setColor(Color.black);
      Drawing.graphics.drawOval(x-RADIUS, y-RADIUS, 2*RADIUS, 2*RADIUS);
      Drawing.paint();
    }
  }
}
